#! /bin/sh
#
#	0.1: Oct. 22, 2002 by Dai ISHIJIMA
#	0.2: May   1, 2004
#

if ! total=`expr "$NCYLS" '*' "$NHEAD" '*' "$NSECS" 2>/dev/null`; then
	echo no disk information
	exit 1
fi

capacity=`expr $NCYLS '*' $NHEAD '*' $NSECS '*' 512`

kb=`expr $capacity / 1024`
mb=`expr $kb / 1024`
gb=`expr $mb / 1024`

max=$total

disk=/dev/rad0
dname=master
case "$1" in
	/dev/*[0-9]) disk="$1" ;;
esac

echo ''
echo "check $disk"
echo "capacity: $capacity [bytes] ($kb [kbytes], $mb [Mbytes], $gb [Gbytes])"
echo -n 'Ok? [y/n]  '

read x
case $x in
	y) ;;
	*) echo 'Aborted'; exit 1;;
esac

echo ''
echo '* STAGE 1 of 6'
echo -n reading boot sector...
dd if=$disk bs=512 count=1 of=/tmp/x 2> /dev/null
case $? in
	0) echo ' done' ;;
	*) echo ''; echo 'READ FAILED' ; exit 1;;
esac

echo -n checking boot sector...
check < /tmp/x > /dev/null
case $? in
	0) echo ' OK, erased' ;;
	1) echo ' May be erased, but not ZERO' ;;
	*) echo ' NOT ERASED' ;;
esac


echo ''
echo '* STAGE 2 of 6'
echo -n checking the first track...
n=1
m=63
z=0
e=0
u=0
while [ $n -lt $m ] ; do
	dd if=$disk bs=512 count=1 skip=$n of=/tmp/x 2> /dev/null
	check < /tmp/x > /dev/null
	case $? in
		0) z=`expr $z + 1` ;;
		1) e=`expr $e + 1` ;;
		*) u=`expr $u + 1` ;;
	esac
	n=`expr $n + 1`
done

echo ''
echo "$z zero-erased sectors, $e nonzero-erased sectors, $u unerased sectors"


echo ''
echo '* STAGE 3 of 6'
echo -n checking the 2nd, 3rd, 4th tracks...
n=63
m=190
z=0
e=0
u=0
while [ $n -lt $m ] ; do
	dd if=$disk bs=512 count=1 skip=$n of=/tmp/x 2> /dev/null
	check < /tmp/x > /dev/null
	case $? in
		0) z=`expr $z + 1` ;;
		1) e=`expr $e + 1` ;;
		*) u=`expr $u + 1` ;;
	esac
	n=`expr $n + 1`
done

echo ''
echo "$z zero-erased sectors, $e nonzero-erased sectors, $u unerased sectors"


echo ''
echo '* STAGE 4 of 6'
echo checking some of start sectors of first partition...
n=189
m=65536
step=3
z=0
e=0
u=0
r=0
while [ $n -lt $m ] ; do
	case $r in
		0) echo -n "
cheking $n of $m ..." ; r=97 ;;
	esac
	r=`expr $r - 1`
	dd if=$disk bs=512 count=1 skip=$n of=/tmp/x 2> /dev/null
	check < /tmp/x > /dev/null
	case $? in
		0) z=`expr $z + 1` ;;
		1) e=`expr $e + 1` ;;
		*) u=`expr $u + 1` ;;
	esac
	n=`expr $n + $step`
done

echo ''
echo "$z zero-erased sectors, $e nonzero-erased sectors, $u unerased sectors"


echo ''
echo '* STAGE 5 of 6'
echo fast checking of data sectors...
n=64
step=10249
z=0
e=0
u=0
r=0
while [ $n -lt $max ] ; do
	case $r in
		0) echo -n "
cheking $n of $max ..." ; r=97 ;;
	esac
	r=`expr $r - 1`
	dd if=$disk bs=512 count=1 skip=$n of=/tmp/x 2> /dev/null
	check < /tmp/x > /dev/null
	case $? in
		0) z=`expr $z + 1` ;;
		1) e=`expr $e + 1` ;;
		*) u=`expr $u + 1` ;;
	esac
	n=`expr $n + $step`
done

echo ''
echo "$z zero-erased sectors, $e nonzero-erased sectors, $u unerased sectors"

	
echo ''
echo '* STAGE 6 of 6'
echo final checking of data sectors...
n=201
step=2049
z=0
e=0
u=0
r=0
while [ $n -lt $max ] ; do
	case $r in
		0) echo -n "
cheking $n of $max ..." ; r=99 ;;
	esac
	r=`expr $r - 1`
	dd if=$disk bs=512 count=1 skip=$n of=/tmp/x 2> /dev/null
	check < /tmp/x > /dev/null
	case $? in
		0) z=`expr $z + 1` ;;
		1) e=`expr $e + 1` ;;
		*) u=`expr $u + 1` ;;
	esac
	n=`expr $n + $step`
done

echo ''
echo "$z zero-erased sectors, $e nonzero-erased sectors, $u unerased sectors"
	
echo ''
echo -n 'Press ENTER to return menu...'
read x

exit 0
